////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
     ////     //        ///     //////////////////////////////////////////        CTG-Pattern_finder-MD.mq4 ////
////////  ////////  //////  ////\////////////////////////////////////////                CompanyName "CTG" /////////
   ////     /////  //////       ////////////////////////////////////////     http://ChaosTradingGroup.com ////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 //// INDICATOR:  Pattern Finder MD (preferably a modified schedule for the periods of history the week lower)  ////
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#property copyright  "Copyright  2007, ChaosTradingGroup.com"
#property link       "http://ChaosTradingGroup.com"

#property indicator_separate_window
#property  indicator_buffers 6

extern string     DATA           = "close";  // volume, body, close, middle, high, low, map
extern datetime   StartDate      = 0;
extern datetime   EndDate        = 0;
extern int        UCmin          = 0;        // unit consciousness in minutes
extern bool       Smoothing      = false;    // smoothing pattern at an average price bar
extern bool       Percentage     = false;    // calculation of percentage pattern

double         b0[],b1[],b2[],b3[],b4[],b5[];

static int     e,i,p,x,iter,swt,Start,End;
static double  prc1_t,prc1_h,prc1_l,prc1_c,prc1_b,prc1_m,Lh,Ll,Lc;

int            clr0,clr1,clr2,clr3,clr4,clr5,
               line,wh,st,st2,wh2,ESbar,n,ESstep,ES,ESstart,EC;
double         centr;
string         txt0,txt1,txt2,txt3,txt4,txt5,txtdata;

//////////////////////////////////////////////////////////////////////
// Init //////////////////////////////////////////////////////////////
int init()
  {
  OptionsControl();
     
  line=DRAW_LINE;wh2=1;st2=0;
  
  if(DATA=="volume" || DATA=="Volume" || DATA=="VOLUME")
   {
   n=1;txtdata="VOLUME";
   txt0="VOLUME";txt1="VOLUME";clr0=Black;clr1=Black;
   txt2="";txt3="";clr2=CLR_NONE;clr3=CLR_NONE;
   txt4="";txt5="";clr4=CLR_NONE;clr5=CLR_NONE;
   }
   else if(DATA=="body" || DATA=="Body" || DATA=="BODY")
         {
         n=2;txtdata="BODY";
         txt0="BODY";txt1="BODY";clr0=Coral;clr1=Coral;
         txt2="";txt3="";clr2=CLR_NONE;clr3=CLR_NONE;
         txt4="";txt5="";clr4=CLR_NONE;clr5=CLR_NONE;
         }
         else if(DATA=="close" || DATA=="Close" || DATA=="CLOSE")
               {
               n=3;txtdata="CLOSE";
               txt0="CLOSE";txt1="CLOSE";clr0=Magenta;clr1=Magenta;
               txt2="";txt3="";clr2=CLR_NONE;clr3=CLR_NONE;
               txt4="";txt5="";clr4=CLR_NONE;clr5=CLR_NONE;
               }
               else if(DATA=="high" || DATA=="High" || DATA=="HIGH")
                     {
                     n=4;txtdata="HIGH";
                     txt0="HIGH";txt1="HIGH";clr0=Blue;clr1=Blue;
                     txt2="";txt3="";clr2=CLR_NONE;clr3=CLR_NONE;
                     txt4="";txt5="";clr4=CLR_NONE;clr5=CLR_NONE;
                     }
                     else if(DATA=="low" || DATA=="Low" || DATA=="LOW")
                           {
                           n=5;txtdata="LOW";
                           txt0="LOW";txt1="LOW";clr0=Red;clr1=Red;
                           txt2="";txt3="";clr2=CLR_NONE;clr3=CLR_NONE;
                           txt4="";txt5="";clr4=CLR_NONE;clr5=CLR_NONE;
                           }
                           else if(DATA=="map" || DATA=="Map" || DATA=="MAP")
                                 {
                                 n=6;txtdata="MAP";
                                 txt0="CLOSE";txt1="CLOSE";clr0=Magenta;clr1=Magenta;
                                 txt2="HIGH";txt3="HIGH";clr2=Blue;clr3=Blue;
                                 txt4="LOW";txt5="LOW";clr4=Red;clr5=Red;
                                 }
                                 else if(DATA=="middle" || DATA=="Middle" || DATA=="MIDDLE")
                                       {
                                       n=7;txtdata="MIDDLE";
                                       txt0="MIDDLE";txt1="MIDDLE";clr0=MediumVioletRed;clr1=MediumVioletRed;
                                       txt2="";txt3="";clr2=CLR_NONE;clr3=CLR_NONE;
                                       txt4="";txt5="";clr4=CLR_NONE;clr5=CLR_NONE;
                                       }
                                       else  {
                                             n=3;txtdata="CLOSE";
                                             txt0="CLOSE";txt1="CLOSE";clr0=Magenta;clr1=Magenta;
                                             txt2="";txt3="";clr2=CLR_NONE;clr3=CLR_NONE;
                                             txt4="";txt5="";clr4=CLR_NONE;clr5=CLR_NONE;
                                             }
   IndicatorBuffers(6);
   
   SetIndexStyle(0,line,st2,wh2,clr0);
   SetIndexEmptyValue(0,0.0);
   SetIndexDrawBegin(0,0.0);
   SetIndexStyle(1,line,st2,wh2,clr1);
   SetIndexEmptyValue(1,0.0);
   SetIndexDrawBegin(1,0.0);
   SetIndexStyle(2,line,st2,wh2,clr2);
   SetIndexEmptyValue(2,0.0);
   SetIndexDrawBegin(2,0.0);
   SetIndexStyle(3,line,st2,wh2,clr3);
   SetIndexEmptyValue(3,0.0);
   SetIndexDrawBegin(3,0.0);
   SetIndexStyle(4,line,st2,wh2,clr4);
   SetIndexEmptyValue(4,0.0);
   SetIndexDrawBegin(4,0.0);
   SetIndexStyle(5,line,st2,wh2,clr5);
   SetIndexEmptyValue(5,0.0);
   SetIndexDrawBegin(5,0.0);
   
   IndicatorDigits(Digits);
   
   SetIndexBuffer(0,b0);
   SetIndexBuffer(1,b1);
   SetIndexBuffer(2,b2);
   SetIndexBuffer(3,b3);
   SetIndexBuffer(4,b4);
   SetIndexBuffer(5,b5);
    
   IndicatorShortName("PF_MD(UC="+EC+","+txtdata+"):");
   SetIndexLabel(0,txt0);
   SetIndexLabel(1,txt1);
   SetIndexLabel(2,txt2);
   SetIndexLabel(3,txt3);
   SetIndexLabel(4,txt4);
   SetIndexLabel(5,txt5);
   
   return(0);
  }
//////////////////////////////////////////////////////////////////////
// Deinit ////////////////////////////////////////////////////////////
int deinit(){Comment("");return(0);}
//////////////////////////////////////////////////////////////////////
// Start /////////////////////////////////////////////////////////////
int start()
  {   
   OptionsControl();
   for(i=0;i<=(Bars-1);i++)
      {
      b0[i]=0;b1[i]=0;b2[i]=0;
      b3[i]=0;b4[i]=0;b5[i]=0;
      }
   ESbar=EC/Period();
   CalcPattern();            
   return(0);
  }
//////////////////////////////////////////////////////////////////////
// Functions /////////////////////////////////////////////////////////
void CalcPattern()
   {
   ESstart=End;ES=ESbar;ESstep=0;
   x=0;iter=1;e=Start;
   for(i=ESstart;i<=(e+1);i++)
      {
      if(x>ES){x=0;iter++;i--;Start=i;}
      x++;
      }
   Comment("Iterations="+(iter-1)+"\n"+"Start="+TimeToStr(Time[Start],TIME_DATE|TIME_MINUTES)+
            "\n"+"End="+TimeToStr(Time[End],TIME_DATE|TIME_MINUTES));
   
   //patern
   p=ESstart;x=0;
   if(Percentage==true){CalcPrc(ES,ESstart);}
   //
   for(i=ESstart;i<=Start;i++)
      {
      if(x>ES){p=ESstart;x=0;i--;CalcPrc(ES,i);}
      //
      if(n==6){b0[p]+=Price(3,i);b2[p]+=Price(4,i);b4[p]+=Price(5,i);}
         else  {b0[p]+=NormalizeDouble(Price(n,i),Digits);}
      //
      p++;x++;
      } 
   //patern iter.  
   for(p=ESstart,x=0;x<=ES;x++,p++)
      {
      if(n==6)
         {
         b0[p]=NormalizeDouble(b0[p],Digits)/(iter-1);
         b2[p]=NormalizeDouble(b2[p],Digits)/(iter-1);
         b4[p]=NormalizeDouble(b4[p],Digits)/(iter-1);
         }
         else  {b0[p]=NormalizeDouble(b0[p],Digits)/(iter-1);}
      }
   //paint
   p=ESstart;x=0;   
   for(i=ESstart;i<=Start;i++)
      {
      if(x>ES)
         {
         p=ESstart;x=0;i--;
         if(swt==0){swt=1;}
            else {swt=0;}
         }
      if(n==6)
         {
         if(swt==0){b0[i]=b0[p];b2[i]=b2[p];b4[i]=b4[p];}
         if(swt==1){b1[i]=b0[p];b3[i]=b2[p];b5[i]=b4[p];}
         }
         else  {
               if(swt==0){b0[i]=b0[p];}
               if(swt==1){b1[i]=b0[p];}
               }
      p++;x++;           
      }
   }
//====================================================================
void CalcPrc(int ESrad,int start)
   {
   static int     s=0;
   static double  b=0,prevb=0;
   
   //price
   Ll=Low[iLowest(NULL,0,MODE_LOW,ESrad,start)];
   prc1_c=((High[iHighest(NULL,0,MODE_HIGH,ESrad,start)]-Ll)/Point)/100;
   if( NormalizeDouble(prc1_c,0) < 1 ){prc1_c=1;}
   Lc=Ll; Lh=Ll; prc1_h=prc1_c; prc1_l=prc1_c;
   //volume
   prc1_t=Volume[iHighest(NULL,0,MODE_VOLUME,ESrad,start)]/100;
   //body
   s=start;
   while(true)
      {
      if( s>(start+ESrad) ){break;}
      b=High[s]-Low[s];
      if( b>prevb ){prevb=b;}
      s++;
      }
   prc1_b=(prevb/Point)/100;
   }
//====================================================================
double Price(int data, int pos)
   {
   double R;
   
   if(Smoothing==true)
      {
      if(Percentage==true)
         {
         switch(data)
            {
            case 1:  centr=(Volume[pos]/2)/prc1_t;                      break;
            case 2:  centr=(((High[pos]-Low[pos])/2)/Point)/prc1_b;     break;
            case 3:  centr=(((High[pos]+Low[pos])/2-Ll)/Point)/prc1_c;  break;
            case 4:  centr=(((High[pos]+Low[pos])/2-Ll)/Point)/prc1_c;  break;
            case 5:  centr=(((High[pos]+Low[pos])/2-Ll)/Point)/prc1_c;  break;
            default: centr=0;                                           break;
            }
         }
         else  {
               switch(data)
                  {
                  case 1:  centr=(Volume[pos]/2);                    break;
                  case 2:  centr=(High[pos]-Low[pos])/2;   break;
                  case 3:  centr=(High[pos]+Low[pos])/2;     break;
                  case 4:  centr=(High[pos]+Low[pos])/2;     break;
                  case 5:  centr=(High[pos]+Low[pos])/2;     break;
                  default: centr=0;                                  break;
                  }
               }
      
      }
      else  {centr=0;}
   if(Percentage==true)
      {
      switch(data)
         {
         case 1:  R=(Volume[pos]/prc1_t)-centr;                   break;
         case 2:  R=(((High[pos]-Low[pos])/Point)/prc1_b)-centr;  break;
         case 3:  R=(((Close[pos]-Lc)/Point)/prc1_c)-centr;       break;
         case 4:  R=(((High[pos]-Lh)/Point)/prc1_h)-centr;        break;
         case 5:  R=(((Low[pos]-Ll)/Point)/prc1_l)-centr;         break;
         case 7:  R=(((High[pos]+Low[pos])/2-Ll)/Point)/prc1_l; break;
         }
      }
      else  {
            switch(data)
               {
               case 1:  R=Volume[pos]-centr;           break;
               case 2:  R=(High[pos]-Low[pos])-centr;  break;
               case 3:  R=(Close[pos])-centr;          break;
               case 4:  R=(High[pos])-centr;           break;
               case 5:  R=(Low[pos])-centr;            break;
               case 7:  R=(High[pos]+Low[pos])/2;      break;
               }
            }
            
   return(NormalizeDouble(R,Digits));
   }
//====================================================================
void OptionsControl()
   {
   if( (UCmin<=Period()) || ( ((Bars-1)*Period())<(UCmin*2) ) ){EC=DefaultEC(Period());}
      else  {EC=UCmin;}
   if(StartDate!=0){Start=iBarShift(NULL,0,StartDate);}
      else  {Start=Bars-1;}
   if(EndDate!=0){End=iBarShift(NULL,0,EndDate);}
      else  {End=Bars-1;}
   if(Start==End){Start=Bars-1;End=0;}
      else  {
            e=End;
            if( (End>Start) && ((End-Start)>=(EC*2/Period())) ){End=Start;Start=e;}
               else  if( (Start>End) && ((Start-End)>=(EC*2/Period())) ){End=End;Start=Start;}
                        else  {Start=Bars-1;End=0;}
            } 
   if( (EC*2/Period()) > (Start-End) ){EC=(Start-End)/2;}
   }
//====================================================================
int DefaultEC(int DEC_period)
   {
   int retDEC;
   
   switch(DEC_period)
      {
      case 1:     retDEC=60;           break;
      case 5:     retDEC=60;           break;
      case 15:    retDEC=1440;         break;
      case 30:    retDEC=1440;         break;
      case 60:    retDEC=1440;         break;
      case 240:   retDEC=10080;        break;
      case 1440:  retDEC=43200;        break;
      case 10080: retDEC=43200*12;     break;
      case 43200: retDEC=43200*12*4;   break;
      default:    retDEC=Period()*10;  break;
      }
      
   return(retDEC);
   }
   